package cn.rankin.cmsweb.controller.product;

import cn.rankin.cmsweb.service.product.TagService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.TagDTO;
import cn.rankin.common.utils.dto.search.TagSearchDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.data.api.product.vo.TagVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/tag")
public class TagController {

    @Autowired
    private TagService tagService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<TagVo>> search(TagSearchDTO searchDTO) {
        return tagService.search(BeanUtil.convertToMap(searchDTO));
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public APIResult<TagVo> getTag(@PathVariable("id") String id) {
        return tagService.getTag(id);
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<TagVo> create(@RequestBody TagDTO tagDTO) {
        return tagService.create(tagDTO);
    }

    @RequestMapping(method = RequestMethod.PUT)
    public APIResult<TagVo> update(@RequestBody TagDTO tagDTO) {
        return tagService.update(tagDTO);
    }

    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public APIResult delete(@PathVariable("id") String id) {
        return tagService.delete(id);
    }
}
