package cn.rankin.cmsweb.controller.trade;

import cn.rankin.cmsweb.service.trade.order.OrderService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.cms.OrderSearchWebDTO;
import cn.rankin.data.api.trade.dto.UserOrderDTO;
import cn.rankin.data.api.trade.vo.UserOrderVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/order")
public class OrderController {

    @Autowired
    private OrderService orderService;

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<UserOrderVo> create(@RequestBody UserOrderDTO userOrderDTO) {
        return orderService.create(userOrderDTO);
    }

    @RequestMapping(value = "/{orderId}", method = RequestMethod.GET)
    public APIResult<UserOrderVo> getOrder(@PathVariable String orderId) {
        return orderService.getOrder(orderId);
    }

    @RequestMapping(value = {"/list", ""}, method = RequestMethod.GET)
    public APIResult<Page<UserOrderVo>> search(OrderSearchWebDTO searchDTO) {
        return orderService.search(searchDTO);
    }

    @RequestMapping(value = "/pay/{orderId}", method = RequestMethod.POST)
    public APIResult<Boolean> pay(@PathVariable("orderId") String orderId) {
        return orderService.pay(orderId);
    }

    @RequestMapping(value = "/pay/{orderId}", method = RequestMethod.DELETE)
    public APIResult<Boolean> cancel(@PathVariable("orderId") String orderId) {
        return orderService.cancel(orderId);
    }
}
