package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.LessonDTO;
import cn.rankin.data.api.product.vo.LessonVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.product.name}")
public interface LessonService {

    @RequestMapping(value = "/lesson/list", method = RequestMethod.GET)
    APIResult<Page<LessonVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/lesson/{id}", method = RequestMethod.GET)
    APIResult<LessonVo> getLesson(@PathVariable("id") String id);

    @RequestMapping(value = "/lesson", method = RequestMethod.POST)
    APIResult<LessonVo> create(@RequestBody LessonDTO lessonDTO);

    @RequestMapping(value = "/lesson", method = RequestMethod.PUT)
    APIResult<LessonVo> update(@RequestBody LessonDTO lessonDTO);

    @RequestMapping(value = "/lesson/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);
}
