package cn.rankin.cmsweb.service.resource;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.resource.ResourceDTO;
import cn.rankin.common.utils.vo.resource.ResourceVo;
import cn.rankin.data.api.resource.OSSSignatureVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

@FeignClient(value = "${service.resource.name}")
public interface ResourceService {

    @RequestMapping(value = "/resource/list")
    APIResult<Page<ResourceVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/resource", method = RequestMethod.POST)
    APIResult<ResourceVo> create(@RequestBody ResourceDTO resourceDTO);

    @RequestMapping(value = "/resource/batch", method = RequestMethod.GET)
    APIResult<Map<String, ResourceVo>> getBatch(@RequestParam("id") List<String> ids);

    @RequestMapping(value = "/oss/signature", method = RequestMethod.GET)
    APIResult<OSSSignatureVo> getSign(@RequestParam("fileName") String fileName);
}
