package cn.rankin.cmsweb.service.trade.order;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.enums.OrderStatusEnum;
import cn.rankin.data.api.trade.dto.UserOrderDTO;
import cn.rankin.data.api.trade.entity.UserOrder;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(name = "${service.trade.name}")
public interface OrderServiceFeign {

    // 此处返回值不用Vo，需要进一步处理
    @RequestMapping(value = "/order/list", method = RequestMethod.GET)
    APIResult<Page<UserOrder>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/order", method = RequestMethod.POST)
    APIResult<UserOrder> create(@RequestBody UserOrderDTO userOrderDTO);

    @RequestMapping(value = "/order/{orderId}", method = RequestMethod.GET)
    APIResult<UserOrder> getOrder(@PathVariable("orderId") String orderId);

    @RequestMapping(value = "/order/pay/{orderId}", method = RequestMethod.POST)
    APIResult<Boolean> pay(@PathVariable("orderId") String orderId, @RequestParam("status") OrderStatusEnum status);

    @RequestMapping(value = "/order/pay/{orderId}", method = RequestMethod.DELETE)
    APIResult<Boolean> cancel(@PathVariable("orderId") String orderId);
}
