package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@ToString
@Entity
@Table(name = "lesson", indexes = {@Index(columnList = "code"), @Index(columnList = "name")})
@DynamicInsert
@DynamicUpdate
public class Lesson implements Serializable {

    @Id
    private String id;

    @Column(nullable = false, unique = true)
    private String code;

    @Column
    private String name;

    @Column
    private String digest;

    @Column
    private Integer sort;

    @Column(nullable = false)
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", updatable = false, insertable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Transient
    private List<Courseware> coursewareList;
}
