package cn.rankin.data.api.product.entity;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import cn.rankin.common.utils.jpa.ListAttributeConverter;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

@Data
@ToString
@Entity
@Table(name = "support", indexes = {@Index(columnList = "code"), @Index(columnList = "name")})
@DynamicInsert
@DynamicUpdate
public class Support implements Serializable {

    @Id
    private String id;

    @Column(unique = true, nullable = false)
    private String code;

    @Column
    private String name;

    @Column
    private String title;

    @Column
    private String digest;

    @Column
    private String detail;

    @Column(name = "img_list")
    @Convert(converter = ListAttributeConverter.class)
    private List<String> imgList;

    @Column(name = "cp_id")
    private String cpId;

    @Enumerated(EnumType.ORDINAL)
    private ProductTypeEnum type;

    @Column
    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    @Column(name = "gmt_created", insertable = false, updatable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

//    @ManyToMany(fetch = FetchType.EAGER)
//    @JoinTable(name = "lj_support_reference", joinColumns = {@JoinColumn(name = "fid", referencedColumnName = "id")},
//            inverseJoinColumns = {@JoinColumn(name = "tid", referencedColumnName = "id")})
    @Transient
    private List<Support> supportList;
}
