package cn.rankin.data.api.trade.entity;

import cn.rankin.common.utils.enums.OrderStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
@ToString
@Entity
@Table(name = "user_order")
@DynamicInsert
@DynamicUpdate
public class UserOrder implements Serializable {

    @Id
    private String id;

    @Column(updatable = false)
    private String uid;

    @Column(name = "origin_price")
    private BigDecimal originPrice;

    @Column(name = "final_price")
    private BigDecimal finalPrice;

    @Column(name = "adjust_price")
    private BigDecimal adjustPrice;

    @Enumerated(EnumType.ORDINAL)
    private OrderStatusEnum status;

    private String note;

    @Column(name = "gmt_created", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreated;

    @Column(name = "gmt_modified", updatable = false, insertable = false, columnDefinition = "timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP")
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtModified;

    @Transient
    private List<OrderGoods> goods;
}
