package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Courseware;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface WareRepository extends BasicJpaRepository<Courseware, String> {

    Long countByCode(String code);

    Long countByIdIn(List<String> Ids);

    @Modifying(clearAutomatically = true)
    @Query(value = "update Courseware w set w.status = :status  where w.id = :id")
    Integer deleteAllById(@Param("id") String id, @Param("status") BaseStatusEnum status);

    @Query(value = "select w from Courseware w where w.id in (:ids) and w.status = :status")
    List<Courseware> findByIdIn(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);

}
