package cn.rankin.tradeservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.trade.entity.UserOrder;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

public interface OrderRepository extends BasicJpaRepository<UserOrder, String> {

    @Modifying(clearAutomatically = true)
    @Query(value = "update UserOrder o set o.status = 1 where o.status = 0 and o.id = ?1")
    Integer pay(String orderId);

    @Modifying(clearAutomatically = true)
    @Query(value = "update UserOrder o set o.status = 4 where o.status = 1 and o.id = ?1")
    Integer send(String orderId);

    @Modifying(clearAutomatically = true)
    @Query(value = "update UserOrder o set o.status = 5 where o.status = 4 and o.id = ?1")
    Integer received(String orderId);

    @Modifying(clearAutomatically = true)
    @Query(value = "update UserOrder o set o.status = 6 where o.status = 5 and o.id = ?1")
    Integer complete(String orderId);

    @Modifying(clearAutomatically = true)
    @Query(value = "update UserOrder o set o.status = 2 where o.status = 0 and o.id = ?1")
    Integer cancel(String orderId);
}
