package cn.rankin.userservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.user.entity.TerminalDevice;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface TerminalDeviceRepository extends BasicJpaRepository<TerminalDevice, String> {

    @Modifying(clearAutomatically = true)
    @Query("update TerminalDevice a set a.status = :status where a.id in (:ids)")
    int updateStatusByIds(@Param("ids") List<Long> ids, @Param("status") BaseStatusEnum status);

    @Modifying(clearAutomatically = true)
    @Query(value = "update TerminalDevice t set t.bind = 0 where t.userId = :userId")
    int unbind(@Param("userId") String userId);

}
